<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des types d'entretiens n'ont pas pu être chargées."
    />
    <template v-else-if="interviewTypeCounts">
      <h2 class="fr-h5">Types d'entretiens</h2>
      <StatsList
        v-if="interviewTypeCounts.length"
        :total-count="totalCount"
        :stats="interviewTypeCounts"
      />
      <p v-else>
        Commencez à créer des synthèses d'entretien dans les fiches de
        bénéficiaires pour voir apparaître les statistiques de la répartition
        des types d'entretiens.
      </p>
    </template>
  </div>
</template>

<script setup>
  import {
    INTERVIEW_TYPE_OPTIONS,
    INTERVIEW_COLOR
  } from '~/utils/constants/interview'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    totalCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: interviewTypeCounts,
    pending,
    error
  } = useLazyAsyncData('interviewTypeCounts', loadinterviewTypeCounts, {
    server: false
  })

  async function loadinterviewTypeCounts() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems('follow_ups', {
      groupBy: 'type',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const _interviewTypeCounts = res.data.data.map(
        ({ type, countDistinct }) => ({
          key: type,
          label: INTERVIEW_TYPE_OPTIONS.get(type),
          color: INTERVIEW_COLOR,
          count: parseInt(countDistinct.id)
        })
      )
      _interviewTypeCounts.sort((a, b) => b.count - a.count)
      return _interviewTypeCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
